<?php
/*
@name Prises GeFOTECH
@author Valentin CARRUESCO & robin5wood <idleman@idleman.fr> 
@link http://robin5wood.free.fr/cms/?Domotique___Commander_des_prises_avec_YANA
@licence CC by nc sa
@version 2.0.0
@description Prises GeFOTECH - 433MHz
*/

include('gefotech.class.php');



function gefotech_plugin_setting_page(){
	global $_,$myUser;
	if(isset($_['section']) && $_['section']=='gefotech' ){

		if($myUser!=false){
			$gefotechManager = new gefotech();
			$gefotechs = $gefotechManager->populate();
			$roomManager = new Room();
			$rooms = $roomManager->populate();

			//Si on est en mode modification
			if (isset($_['id'])){
				$id_mod = $_['id'];
				$selected = $gefotechManager->getById($id_mod);
				$description = $selected->GetName();
				$button = "Modifier";
			}
			//Si on est en mode ajout
			else
			{
				$description =  "Ajout d'une prise GeFOTECH - 433MHz";
				$button = "Ajouter";
			}
			?>

			<div class="span9 userBloc">


				<h1>Prises GeFOTECH</h1>
				<p>Gestion des prises GeFOTECH - 433MHz</p>  
				<form action="action.php?action=gefotech_add_gefotech" method="POST">
					<fieldset>
						<legend><? echo $description ?></legend>

						<div class="left">
							<label for="namegefotech">Nom</label>
							<? if(isset($selected)){echo '<input type="hidden" name="id" value="'.$id_mod.'">';} ?>
							<input type="text" id="namegefotech" value="<? if(isset($selected)){echo $selected->getName();} ?>" onkeyup="$('#vocalCommand').html($(this).val());" name="namegefotech" placeholder="Lumiere Canapé…"/>
							<small>Commande vocale associée : "YANA, allume <span id="vocalCommand"></span>"</small>
							<label for="descriptiongefotech">Description</label>
							<input type="text" value="<? if(isset($selected)){echo $selected->getDescription();} ?>" name="descriptiongefotech" id="descriptiongefotech" placeholder="Relais sous le canapé…" />
							<label for="telecommandeCodegefotech">Code radio de la telecommande</label>
							<input type="text" value="<? if(isset($selected)){echo $selected->getTelecommandeCode();} ?>" name="telecommandeCodegefotech" id="telecommandeCodegefotech" placeholder="10000,11100,10101…" />
							<label for="priseCodegefotech">Code radio de la prise</label>
							<input type="text" value="<? if(isset($selected)){echo $selected->getPriseCode();} ?>" name="priseCodegefotech" id="priseCodegefotech" placeholder="10000,01000,00100…" />
							<label for="roomgefotech">Pièce</label>
							<select name="roomgefotech" id="roomgefotech">
								<?php foreach($rooms as $room){ 
									if (isset($selected)){$selected_room = ($selected->getRoom());}
									else{$selected_room = null;}			    		
									?>

									<option <? if ($selected_room == $room->getId()){echo "selected";} ?> value="<?php echo $room->getId(); ?>"><?php echo $room->getName(); ?></option>
									<?php } ?>
								</select>
							</div>

							<div class="clear"></div>
							<br/><button type="submit" class="btn"><? echo $button; ?></button>
						</fieldset>
						<br/>
					</form>

					<table class="table table-striped table-bordered table-hover">
						<thead>
							<tr>
								<th>Nom</th>
								<th>Description</th>
								<th>Code télécommande</th>
								<th>Code prise</th>
								<th>Pièce</th>
								<th>Status</th>
								<th></th>
							</tr>
						</thead>

						<?php foreach($gefotechs as $gefotech){ 

							$room = $roomManager->load(array('id'=>$gefotech->getRoom())); 
							?>
							<tr>
								<td><?php echo $gefotech->getName(); ?></td>
								<td><?php echo $gefotech->getDescription(); ?></td>
								<td><?php echo $gefotech->getTelecommandeCode(); ?></td>
								<td><?php echo $gefotech->getPriseCode(); ?></td>
								<td><?php echo $room->getName(); ?></td>
								<td><?php echo $gefotech->getPriseStatus(); ?></td>
								<td><a class="btn" href="action.php?action=gefotech_delete_gefotech&id=<?php echo $gefotech->getId(); ?>"><i class="icon-remove"></i></a>
									<a class="btn" href="setting.php?section=gefotech&id=<?php echo $gefotech->getId(); ?>"><i class="icon-edit"></i></a></td>
								</tr>
								<?php } ?>
							</table>
						</div>

						<?php }else{ ?>

						<div id="main" class="wrapper clearfix">
							<article>
								<h3>Vous devez être connecté</h3>
							</article>
						</div>
						<?php
					}
				}

			}

			function gefotech_plugin_setting_menu(){
				global $_;
				echo '<li '.(isset($_['section']) && $_['section']=='gefotech'?'class="active"':'').'><a href="setting.php?section=gefotech"><i class="icon-chevron-right"></i> Prise GeFOTECH</a></li>';
			}




			function gefotech_display($room){
				global $_;


				$gefotechManager = new gefotech();
				$gefotechs = $gefotechManager->loadAll(array('room'=>$room->getId()));

				foreach ($gefotechs as $gefotech) {

					?>

					<div class="span3 relayBloc">
						<h5 class="label label-info"><?php echo $gefotech->getName() ?></h5>	
						<p><?php echo $gefotech->getDescription() ?>
						</p><ul>
						<li>Type : <span>Prise commandee radio</span></li>
						<li>Code : <span class="label label-warning"><?php echo $gefotech->getTelecommandeCode() ?></span>&nbsp;<span class="label label-warning"><?php echo $gefotech->getPriseCode() ?></span></li>
						<li>Emplacement : <span><?php echo $room->getName() ?></span></li>
					</ul>
				<?php  if(fileperms(Plugin::path().'radioEmission')!='36333'){ ?><span style="width:98%" class="label label-important">Attention, les droits vers le fichier <br/> radioEmission sont mal réglés.<br/> Référez vous à <span style="cursor:pointer;text-decoration:underline;" onclick="window.location.href='https://github.com/ldleman/yana-server#installation';">la doc</span> pour les régler</span><?php } ?>
					
					<div class="btn-toolbar">
						<div class="btn-group">
							<a class="btn <?php if ($gefotech->getPriseStatus()) echo"btn-success"?>" href="action.php?action=gefotech_change_state&engine=<?php echo $gefotech->getId() ?>&amp;telecommande=<?php echo $gefotech->getTelecommandeCode() ?>&amp;prise=<?php echo $gefotech->getPriseCode() ?>&amp;state=on"><i class="icon-thumbs-up icon-white"></i></a>
							<a class="btn <?php if ($gefotech->getPriseStatus()) {echo"";} else echo"btn-danger"?>" href="action.php?action=gefotech_change_state&engine=<?php echo $gefotech->getId() ?>&amp;telecommande=<?php echo $gefotech->getTelecommandeCode() ?>&amp;prise=<?php echo $gefotech->getPriseCode() ?>&amp;state=off"><i class="icon-thumbs-down "></i></a>
						</div>
					</div>
				</div>


				<?php
			}
		}

		function gefotech_vocal_command(&$response,$actionUrl){
			$gefotechManager = new gefotech();

			$gefotechs = $gefotechManager->populate();
			foreach($gefotechs as $gefotech){
				$response['commands'][] = array('command'=>VOCAL_ENTITY_NAME.', allume '.$gefotech->getName(),'url'=>$actionUrl.'?action=gefotech_change_state&engine='.$gefotech->getId().'&state=on&webservice=true','confidence'=>'0.9');
				$response['commands'][] = array('command'=>VOCAL_ENTITY_NAME.', eteint '.$gefotech->getName(),'url'=>$actionUrl.'?action=gefotech_change_state&engine='.$gefotech->getId().'&state=off&webservice=true','confidence'=>'0.9');
			}
		}

		function gefotech_action_gefotech(){
			global $_,$conf,$myUser;

	//Mise à jour des droits
			$myUser->loadRight();

			switch($_['action']){
				case 'gefotech_delete_gefotech':
				if($myUser->can('Prises GeFOTECH','d')){
					$gefotechManager = new gefotech();
					$gefotechManager->delete(array('id'=>$_['id']));
					header('location:setting.php?section=gefotech');
				}
				else
				{
					header('location:setting.php?section=gefotech&error=Vous n\'avez pas le droit de faire ça!');
				}

				break;
				case 'gefotech_plugin_setting':
				$conf->put('plugin_gefotech_emitter_pin',$_['emiterPin']);
				header('location: setting.php?section=preference&block=gefotech');
				break;

				case 'gefotech_add_gefotech':

				//Vérifie si on veut modifier ou ajouter un relai
				$right_toverify = isset($_['id']) ? 'u' : 'c';

				if($myUser->can('Prises GeFOTECH',$right_toverify)){
					$gefotech = new gefotech();
					//Si modification on charge la ligne au lieu de la créer
					if ($right_toverify == "u"){$gefotech = $gefotech->load(array("id"=>$_['id']));}
					$gefotech->setName($_['namegefotech']);
					$gefotech->setDescription($_['descriptiongefotech']);
					$gefotech->setTelecommandeCode($_['telecommandeCodegefotech']);
					$gefotech->setPriseCode($_['priseCodegefotech']);
					$gefotech->setRoom($_['roomgefotech']);
					$gefotech->save();
					header('location:setting.php?section=gefotech');
				}
				else
				{
					header('location:setting.php?section=gefotech&error=Vous n\'avez pas le droit de faire ça!');
				}


				break;

				case 'gefotech_change_state':
				global $_,$myUser;


				if($myUser->can('Prises GeFOTECH','u')){
					$gefotech = new gefotech();
					$gefotech = $gefotech->getById($_['engine']);
					if($_['state']=='on'){
					$gefotech->setPriseStatus(1);
					}
					else{
					$gefotech->setPriseStatus(0);
					}
					$gefotech->save();
					$cmd = dirname(__FILE__).'/radioEmission '.$conf->get('plugin_gefotech_emitter_pin').' '.$gefotech->getTelecommandeCode().' '.$gefotech->getPriseCode().' '.$_['state'];

				//TODO change bdd state
					system('nohup '.$cmd.' &',$out);
					if(!isset($_['webservice'])){
						header('location:index.php?module=room&id='.$gefotech->getRoom());
					}else{
						$affirmations = array(	'A vos ordres!',
							'Bien!',
							'Oui commandant!',
							'Avec plaisir!',
							'J\'aime vous obéir!',
							'Avec plaisir!',
							'Certainement!',
							'Je fais ça sans tarder!',
							'Avec plaisir!',
							'Oui chef!');
						$affirmation = $affirmations[rand(0,count($affirmations)-1)];
						$response = array('responses'=>array(
							array('type'=>'talk','sentence'=>$affirmation)
							)
						);

						$json = json_encode($response);
						echo ($json=='[]'?'{}':$json);
					}
				}else{
					$response = array('responses'=>array(
						array('type'=>'talk','sentence'=>'Je ne vous connais pas, je refuse de faire ça!')
						)
					);
					echo json_encode($response);
				}
				break;
			}
		}


		function gefotech_plugin_preference_menu(){
			global $_;
			echo '<li '.(@$_['block']=='gefotech'?'class="active"':'').'><a  href="setting.php?section=preference&block=gefotech"><i class="icon-chevron-right"></i> Prise GeFOTECH</a></li>';
		}
		function gefotech_plugin_preference_page(){
			global $myUser,$_,$conf;
			if((isset($_['section']) && $_['section']=='preference' && @$_['block']=='gefotech' )  ){
				if($myUser!=false){
					?>

					<div class="span9 userBloc">
						<form class="form-inline" action="action.php?action=gefotech_plugin_setting" method="POST">

							<p>Pin du raspberry PI branché à l'émetteur radio: </p>
							<input type="text" class="input-large" name="emiterPin" value="<?php echo $conf->get('plugin_gefotech_emitter_pin');?>" placeholder="Pin wiring PI...">

							<button type="submit" class="btn">Enregistrer</button>
						</form>
					</div>

					<?php }else{ ?>

					<div id="main" class="wrapper clearfix">
						<article>
							<h3>Vous devez être connecté</h3>
						</article>
					</div>
					<?php

				}
			}
		}


		Plugin::addHook("preference_menu", "gefotech_plugin_preference_menu"); 
		Plugin::addHook("preference_content", "gefotech_plugin_preference_page"); 

		Plugin::addCss("/css/style.css"); 
		Plugin::addHook("action_post_case", "gefotech_action_gefotech"); 

		Plugin::addHook("node_display", "gefotech_display");   
		Plugin::addHook("setting_bloc", "gefotech_plugin_setting_page");
		Plugin::addHook("setting_menu", "gefotech_plugin_setting_menu");  
		Plugin::addHook("vocal_command", "gefotech_vocal_command");
		?>
